#include <iostream>
#include <vector>
#include <cstdio>
#include <queue>

using namespace std;

//const int MAXN = 1e5+5;


typedef pair<int,int> ii;
typedef vector<ii> vii;
// muitos problemas de grafos requerem uso de vetor de visitados, etc...
typedef vector<int> vi;

// a lista de adjacencia é um vetor de vii !!!
vector<vii> AdjList;


vector<int> ordTop;     // armazena a ordenacao topologica...
vector<int> gEntr; // grau de entrada do vertice v


void printList(int nv){
	for (int i = 0; i <= nv; ++i){
		printf("%d -> ", i);
		for (int j = 0; j < AdjList[i].size(); ++j){
			printf("(%d %d) -> ", AdjList[i][j].first, AdjList[i][j].second);
		}
		printf("\n");
	}
	printf("\n");
}


void khan(int nv){

	// primeiro, atualiza o grau de entrada de todos os vértices
	for (int u = 1; u <=nv; ++u){
		// para todos os adj v de u
		for (int i = 0; i < AdjList[u].size(); ++i){
			int v = AdjList[u][i].first;
			gEntr[v]++; 
		}
	}

	// cria uma fila e coloca todos os de grau 0 nela...
	queue<int> q;
	for (int u = 1; u <=nv; ++u){
		if (gEntr[u] == 0){
			q.push(u);
			//printf("%d\n", u);
		}
		
	}

	while(!q.empty()){
		// retira da fila e coloca no vetor de ordTop
		int u = q.front(); q.pop();
		ordTop.push_back(u);
		// para todos os adj v de u decrementa o grau de entrada
		for (int i = 0; i < AdjList[u].size(); ++i){
			int v = AdjList[u][i].first;
			gEntr[v]--;
			// se o grau se tornou zero, coloca na fila
			if (gEntr[v] == 0)
				q.push(v); 
		}
	}


}

int main(int argc, char const *argv[])
{
	int nv;
	int u,v;

	cin >> nv;
	//vector<vii> AdjList(nv);
	//vii oi(nv);
	AdjList.assign(nv+1,vii());
	

	//ordTop.assign(nv+1, 0);
	gEntr.assign(nv+1, 0);

	// le o grafo... (direcionado)
	while(cin >> u >> v){
		AdjList[u].push_back(ii(v,0));
	}
	printList(nv);

	khan(nv);
	for (int i = 0; i < nv; ++i){
		printf("%d ** ", ordTop[i]);
	}

	/* code */
	return 0;
}