//Como usar STL para construir uma lista de adjacencia para representacao de GRAFOS
// Traverse the graph DFS...

#include<iostream>
#include<cstdio>
#include<vector>

using namespace std;

#define VIS 1
#define NAOVIS 0

typedef pair<int,int> ii;
typedef vector<ii> vii;
// muitos problemas de grafos requerem uso de vetor de visitados, etc...
typedef vector<int> vi;

// a lista de adjacencia é um vetor de vii !!!
vector<vii> AdjList;

//vetor de vertices (VIS ou NAOVIS)
vi vertices;


vi ordTop;     // armazena a ordenacao topologica...

void printList(int nv){
	for (int i = 0; i <= nv; ++i){
		printf("%d -> ", i);
		for (int j = 0; j < AdjList[i].size(); ++j){
			printf("(%d %d) -> ", AdjList[i][j].first, AdjList[i][j].second);
		}
		printf("\n");
	}
	printf("\n");
}


void dfs(int u){
	vertices[u] = VIS; // marca u como visitado
	//printf("%d ** ", u);
	// para todos os adj v de u
	for (int i = 0; i < AdjList[u].size(); ++i){
		int v = AdjList[u][i].first;
		int w = AdjList[u][i].second;
		if (vertices[v] == NAOVIS)
			dfs(v);
		//else {
		//	printf("OPA... grafo ciclico !!!!\n");
		//	exit(0);
		//}


	}
	// coloca o vertice u no vetor...
	ordTop.push_back(u);
	printf("%d\n", u);

}


int main(int argc, char const *argv[])
{
	int nv;
	int u,v;

	cin >> nv;
	//vector<vii> AdjList(nv);
	//vii oi(nv);
	AdjList.assign(nv+1,vii());

	//AdjList.assign(oi.begin(), oi.end());
	vertices.assign(nv+1, NAOVIS);

	// le o grafo... (nao direcionado)
	while(cin >> u >> v){
		AdjList[u].push_back(make_pair(v,0));
	}
	printList(nv);


	for (int i = 1; i <= nv; ++i){
		if (vertices[i] == NAOVIS)
			dfs(i);
	}

	for (int i = nv-1; i >=0; i--){
		printf("%d **", ordTop[i]);
	}
	return 0;
}